#!/usr/bin/perl
#
# Erstellt einen FAQ-Index
#

require "cgi.pl";

#############
# config here
#############
$rootdir = "/export/htdocs/faq";
$title = "B\&uuml;rgernetz Dillingen FAQs";
$back = "bg.gif";
$FZ_GIF = "fz.gif";
$AZ_GIF = "az.gif";
#############

# normally no config
$headerfile = "header.html";
$footerfile = "footer2.html";

#########################
#define my functions
#########################

# my global variables
%fl;
%body;
@allfiles;

sub printfile {
	local($filename) = @_;

	open MYFILE, $filename;
	while(<MYFILE>) {
		print;
	}
	close MYFILE;
}

sub readfaqfile {
	local($filename) = @_;
	local($firstline, $bd);

	open MYFILE, $filename;
	$firstline = <MYFILE>;

	$fl{$filename} = $firstline;

	while(<MYFILE>)
	{
		$bd = $bd . $_;
	}

	$body{$filename} = $bd;
}

sub printfaqindex {
	my($i);
	my($ww);

	print "<list>";

	$i = 0;
	foreach $ww (@allfiles) {
		$i++;
		print <<EOF;
			<li><a href="#${i}">$fl{$ww}</a>
EOF
	}

	print "</list>";
}

sub printfaqfile {
	my($i);

	$i = 0;

	foreach $ww (@allfiles) {
		$i++;
		print <<XYZ;
			<a name="${i}"> 
			    <tr>
					<td><font face=\"Arial\"><img src=\"${FZ_GIF}\"
		            alt=\"Fragezeichen\" width=\"43\" height=\"57\"> </font></td>
		            <td><font face=\"Arial\"><b>$fl{${ww}}</b> </font></td></tr>

      			<tr>
			        <td><font face=\"Arial\"><img src=\"${AZ_GIF}\"
   			        alt=\"Ausrufezeichen\" width=\"43\" height=\"57\"> </font></td>
					<td><font face=\"Arial\">
XYZ

		print $body{${ww}};

		print <<EOF;
		  </font></td></tr>
EOF

	}

	close MYFILE;
}

#########################
# main program
#########################

# first decode the CGI-Info
%request = &checklocal;
if(!defined %request) {
	%request = &cgiparse();
}

# first of all HTML-Header
&printheader();
&HtmlStart($title, $back);

# print the header of the INDEX
&printfile($headerfile);

# process the dirs and create index
# use rootdir to prevent security whole ;-)
# cause otherwise you could use "/etc" as faqdir
# and display all files there ...
opendir MYDIR, "$rootdir" . "/" . "$request{'faqdir'}";

# ignore "." and ".."
readdir MYDIR;
readdir MYDIR;

@allfiles = readdir MYDIR;

chdir($request{'faqdir'});

foreach $ww (@allfiles) {
	print "<p><p>";
	$filepath = $ww;
	&readfaqfile($filepath);
}

chdir("..");

&printfaqindex();

print "<p><hr><p>";

print "<table border=\"0\" width=\"100%\">";

printfaqfile($ww);

print "</table>";

closedir MYDIR;

&printfile($footerfile);
